Crypto++ 8.2 Free C++ class library of cryptographic schemes

Public Member Functions | List of all members
SipHash< C, D, T_128bit > Class Template Reference

SipHash message authentication code. More...

Inheritance diagram for SipHash< C, D, T_128bit >:

## Public Member Functions
| SipHash ()
| Create a SipHash.
| SipHash (const byte *key, unsigned int length)
| Create a SipHash. More...
Public Member Functions inherited from SipHash_Base< C, D, T_128bit >
virtual unsigned int | DigestSize () const
| Provides the digest size of the hash. More...
virtual size_t | MinKeyLength () const
| Returns smallest valid key length. More...
virtual size_t | MaxKeyLength () const
| Returns largest valid key length. More...
virtual size_t | DefaultKeyLength () const
| Returns default key length. More...
virtual size_t | GetValidKeyLength (size_t keylength) const
| Returns a valid key length for the algorithm. More...
virtual IV_Requirement | IVRequirement () const
| Minimal requirement for secure IVs. More...
virtual unsigned int | IVSize () const
| Returns length of the IV accepted by this object. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash. More...
virtual unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
virtual void | Update (const byte *input, size_t length)
| Updates a hash with additional input. More...
virtual void | TruncatedFinal (byte *digest, size_t digestSize)
| Computes the hash of the current message. More...
Public Member Functions inherited from SimpleKeyingInterface
virtual bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length. More...
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object. More...
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object. More...
bool | IsResynchronizable () const
| Determines if the object can be resynchronized. More...
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs. More...
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs. More...
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs. More...
unsigned int | DefaultIVLength () const
| Provides the default size of an IV. More...
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV. More...
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV. More...
virtual void | Resynchronize (const byte *iv, int ivLength=-1)
| Resynchronize with an IV. More...
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual unsigned int | BlockSize () const
| Provides the block size of the compression function. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Additional Inherited Members
Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...
Static Public Member Functions inherited from SipHash_Base< C, D, T_128bit >
static std::string | StaticAlgorithmName ()
Static Public Member Functions inherited from SipHash_Info< T_128bit >
static const char * | StaticAlgorithmName ()
Static Public Member Functions inherited from FixedKeyLength< 16 >
static size_t CRYPTOPP_API | StaticGetValidKeyLength (size_t keylength)
| The default key length for the algorithm provided by a static function. More...
Static Public Attributes inherited from SipHash_Info< T_128bit >
static const int | DIGESTSIZE = (T_128bit ? 16 : 8)
Static Public Attributes inherited from FixedKeyLength< 16 >
static const int | KEYLENGTH
| The default key length used by the algorithm provided as a constant. More...
static const int | MIN_KEYLENGTH
| The minimum key length used by the algorithm provided as a constant. More...
static const int | MAX_KEYLENGTH
| The maximum key length used by the algorithm provided as a constant. More...
static const int | DEFAULT_KEYLENGTH
| The default key length used by the algorithm provided as a constant. More...
static const int | IV_REQUIREMENT
| The default IV requirements for the algorithm provided as a constant. More...
static const int | IV_LENGTH
| The default IV length used by the algorithm provided as a constant. More...

## Detailed Description

### template<unsigned int C = 2, unsigned int D = 4, bool T_128bit = false>
class SipHash< C, D, T_128bit >

SipHash message authentication code.

Template Parameters

  C | the number of compression rounds
  D | the number of finalization rounds
  T_128bit | flag indicating 128-bit (true) versus 64-bit (false) digest size

SipHash computes a 64-bit or 128-bit message authentication code from a variable-length message and 128-bit secret key. It was designed to be efficient even for short inputs, with performance comparable to non-cryptographic hash functions.

To create a SipHash-2-4 object with a 64-bit MAC use code similar to the following.

      SecByteBlock key(16);
      prng.GenerateBlock(key, key.size());

      SipHash<2,4,false> hash(key, key.size());
      hash.Update(...);
      hash.Final(...);

To create a SipHash-2-4 object with a 128-bit MAC use code similar to the following.

      SecByteBlock key(16);
      prng.GenerateBlock(key, key.size());

      SipHash<2,4,true> hash(key, key.size());
      hash.Update(...);
      hash.Final(...);

See also
  Jean-Philippe Aumasson and Daniel J. Bernstein SipHash: a fast short-input PRF

Since
  Crypto++ 6.0

Definition at line 141 of file siphash.h.

## Constructor & Destructor Documentation

## ◆ SipHash()

template<unsigned int C = 2, unsigned int D = 4, bool T_128bit = false>

SipHash< C, D, T_128bit >::SipHash | ( | const byte * | key,
|  | unsigned int | length
| ) |  |
| inline

Create a SipHash.

Parameters

  key | a byte array used to key the cipher
  length | the size of the byte array, in bytes

Definition at line 150 of file siphash.h.

The documentation for this class was generated from the following file:

- siphash.h